# BEGIN SourceDeps(oneline):
BuildRequires: gcc-c++
# END SourceDeps(oneline)
Name:           iml
Version:        1.0.3
Release:        alt1_5
Summary:        Finds solutions to systems of linear equations over integers
Group:          Engineering
License:        BSD
URL:            http://www.cs.uwaterloo.ca/~astorjoh/iml.html
Source0:        http://www.cs.uwaterloo.ca/~astorjoh/%{name}-%{version}.tar.gz
# This patch will not be sent upstream, as it is Fedora specific.  Configure
# checks whether the system realloc() has either of two bugs and, if so,
# uses a wrapper around realloc() to work around the bugs.  Glibc does not
# have those bugs, so the wrapper is unnecessary.  However, it gets linked
# into the final library anyway.  The wrapper code is GPLv2+ and iml is BSD.
# Since the workaround is not used on Fedora systems anyway, this patch
# prevents it from being linked in, allowing iml to remain straight BSD.
Patch0:         %{name}-no-repl.patch
# Support building on aarch64
Patch1:         %{name}-aarch64.patch

BuildRequires:  libatlas-devel
BuildRequires: libgmp-devel libgmp_cxx-devel
Source44: import.info


%description
IML provides efficient routines to compute exact solutions to dense
systems of linear equations over the integers.  The following
functionality is provided:
- Nonsingular rational system solving.
- Compute the right nullspace of an integer matrix.
- Certified linear system solving.


%package        devel
Summary:        Development files for %{name}
Group:          Development/C
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.


%package        static
Summary:        Static library for %{name}
Group:          Development/C
Requires:       %{name}-devel%{?_isa} = %{version}-%{release}

%description    static
The %{name}-static package contains a static library for %{name}.


%prep
%setup -q
%patch0
%patch1

# Fix a typo in iml 1.0.3
sed -i 's/mpz_init_ui/mpz_init_set_ui/' src/nullspace.c


%build
%configure --enable-shared \
  --with-atlas-include=%{_includedir}/atlas \
  --with-atlas-lib=%{_libdir}/atlas \
  LDFLAGS="-L%{_libdir}/atlas"

# Remove an unnecessary direct shared library dependency
sed -i 's/ -latlas//' src/Makefile

make %{?_smp_mflags}


%install
make install DESTDIR=$RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -fr $RPM_BUILD_ROOT%{_datadir}/%{name}


%check
make check


%files
%doc AUTHORS README
%{_libdir}/lib%{name}.so.*


%files devel
%doc doc/liblink doc/libroutines examples
%{_includedir}/*
%{_libdir}/lib%{name}.so


%files static
%{_libdir}/lib%{name}.a


%changelog
* Tue Apr 02 2013 Igor Vlasenko <viy@altlinux.ru> 1.0.3-alt1_5
- update to new release by fcimport

* Fri Mar 08 2013 Igor Vlasenko <viy@altlinux.ru> 1.0.3-alt1_4
- update to new release by fcimport

* Mon Jan 21 2013 Igor Vlasenko <viy@altlinux.ru> 1.0.3-alt1_3
- initial fc import

